/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of AIO.xs. Do not edit this file, edit AIO.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "AIO.xs"
#include "libeio/xthread.h"

#include <errno.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "schmorp.h"

#include <stddef.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <limits.h>
#include <fcntl.h>
#include <sched.h>

#if _POSIX_MEMLOCK || _POSIX_MEMLOCK_RANGE || _POSIX_MAPPED_FILES
# include <sys/mman.h>
#endif

#if __linux__
# include <linux/fs.h>
# ifdef FS_IOC_FIEMAP
#  include <linux/types.h>
#  include <linux/fiemap.h>
#  define HAVE_FIEMAP 1
# endif
#endif

/* perl namespace pollution */
#undef VERSION

/* perl stupidly overrides readdir and maybe others */
/* with thread-unsafe versions, imagine that :( */
#undef readdir
#undef opendir
#undef closedir

#ifdef _WIN32

  // perl overrides all those nice libc functions

  #undef malloc
  #undef free
  #undef open
  #undef read
  #undef write
  #undef send
  #undef recv
  #undef stat
  #undef lstat
  #undef fstat
  #undef truncate
  #undef ftruncate
  #undef open
  #undef link
  #undef close
  #undef unlink
  #undef mkdir
  #undef rmdir
  #undef rename
  #undef lseek
  #undef opendir
  #undef readdir
  #undef closedir
  #undef chmod
  #undef fchmod
  #undef dup
  #undef dup2
  #undef abort
  #undef pipe

  #define EIO_STRUCT_STAT struct _stati64
  #define EIO_STRUCT_STATI64

#else

  #include <sys/time.h>
  #include <sys/select.h>
  #include <unistd.h>
  #include <utime.h>
  #include <signal.h>

  #define EIO_STRUCT_STAT Stat_t

#endif

/*****************************************************************************/

#if __GNUC__ >= 3
# define expect(expr,value) __builtin_expect ((expr),(value))
#else
# define expect(expr,value) (expr)
#endif

#define expect_false(expr) expect ((expr) != 0, 0)
#define expect_true(expr)  expect ((expr) != 0, 1)

/*****************************************************************************/

typedef SV SV8; /* byte-sv, used for argument-checking */
typedef int aio_rfd; /* read file desriptor */
typedef int aio_wfd; /* write file descriptor */

static HV *aio_stash, *aio_req_stash, *aio_grp_stash, *aio_wd_stash;

#define EIO_REQ_MEMBERS	\
  SV *callback;		\
  SV *sv1, *sv2;	\
  SV *sv3, *sv4;	\
  STRLEN stroffset;	\
  SV *self;

#define EIO_NO_WRAPPERS 1

#include "libeio/config.h"
#include "libeio/eio.h"

static int req_invoke    (eio_req *req);
#define EIO_FINISH(req)  req_invoke (req)
static void req_destroy  (eio_req *grp);
#define EIO_DESTROY(req) req_destroy (req)

#include "libeio/eio.c"

#if !HAVE_POSIX_FADVISE
# define posix_fadvise(a,b,c,d) errno = ENOSYS /* also return ENOSYS */
#endif

#if !HAVE_POSIX_MADVISE
# define posix_madvise(a,b,c) errno = ENOSYS /* also return ENOSYS */
#endif

#ifndef MAP_ANONYMOUS
# ifdef MAP_ANON
#  define MAP_ANONYMOUS MAP_ANON
# else
#  define MAP_ANONYMOUS MAP_FIXED /* and hope this fails */
# endif
#endif

/* defines all sorts of constants to 0 unless they are already defined */
#include "def0.h"

#ifndef makedev
# define makedev(maj,min) (((maj) << 8) | (min))
#endif
#ifndef major
# define major(dev) ((dev) >> 8)
#endif
#ifndef minor
# define minor(dev) ((dev) & 0xff)
#endif

#ifndef PAGESIZE
# define PAGESIZE sysconf (_SC_PAGESIZE)
#endif

/*****************************************************************************/

static void
fiemap (eio_req *req)
{
  req->result = -1;

#if HAVE_FIEMAP
  int count = req->int3;

  /* heuristic: first try with 64 extents if we don't know how many, */
  /* as most files have (hopefully) fewer than this many extents */
  /* in fact, most should have <= 2, so maybe the 72 below is probably overkill */
  if (count < 0)
    count = 72; /* for what it's worth, 72 extents fit nicely into 4kb */

  for (;;)
    {
      struct fiemap *fiemap = malloc (sizeof (*fiemap) + sizeof (struct fiemap_extent) * count);
      errno = ENOMEM;
      if (!fiemap)
        return;

      req->ptr1 = fiemap;
      req->flags |= EIO_FLAG_PTR1_FREE;

      fiemap->fm_start        = req->offs;
      fiemap->fm_length       = req->size;
      fiemap->fm_flags        = req->int2;
      fiemap->fm_extent_count = count;

      if (ioctl (req->int1, FS_IOC_FIEMAP, fiemap))
        return;

      if (req->int3 >= 0)
        break; /* when not autosizing we are done */

      if (fiemap->fm_extents [fiemap->fm_mapped_extents - 1].fe_flags & FIEMAP_EXTENT_LAST)
        break; /* autosizing successful, we are done */

      fiemap->fm_flags        = req->int2;
      fiemap->fm_extent_count = 0;

      if (ioctl (req->int1, FS_IOC_FIEMAP, fiemap))
        return;

      count = fiemap->fm_mapped_extents;

      free (fiemap);
    }

  req->result = 0;

#else
  errno = ENOSYS;
#endif
}

/*****************************************************************************/

enum {
  FLAG_SV2_RO_OFF = 0x40, /* data was set readonly */
};

typedef eio_req *aio_req;
typedef eio_req *aio_req_ornot;
typedef eio_wd   aio_wd;

static SV *on_next_submit;
static int next_pri = EIO_PRI_DEFAULT;
static int max_outstanding;

static s_epipe respipe;

static void req_destroy (aio_req req);
static void req_cancel (aio_req req);

static void
want_poll (void)
{
  /* write a dummy byte to the pipe so fh becomes ready */
  s_epipe_signal (&respipe);
}

static void
done_poll (void)
{
  /* read any signals sent by the worker threads */
  s_epipe_drain (&respipe);
}

/* must be called at most once */
static SV *
req_sv (aio_req req, HV *stash)
{
  if (!req->self)
    {
      req->self = (SV *)newHV ();
      sv_magic (req->self, 0, PERL_MAGIC_ext, (char *)req, 0);
    }

  return sv_2mortal (sv_bless (newRV_inc (req->self), stash));
}

static SV *
newSVaio_wd (aio_wd wd)
{
  return sv_bless (newRV_noinc (newSViv ((IV)wd)), aio_wd_stash);
}

static aio_req
SvAIO_REQ (SV *sv)
{
  MAGIC *mg;

  if (!SvROK (sv)
      /* for speed reasons, we do not verify that SvROK actually has a stash ptr */
      || (SvSTASH (SvRV (sv)) != aio_grp_stash
          && SvSTASH (SvRV (sv)) != aio_req_stash
          && !sv_derived_from (sv, "IO::AIO::REQ")))
    croak ("object of class IO::AIO::REQ expected");

  mg = mg_find (SvRV (sv), PERL_MAGIC_ext);

  return mg ? (aio_req)mg->mg_ptr : 0;
}

static aio_wd
SvAIO_WD (SV *sv)
{
  if (!SvROK (sv)
      || SvTYPE (SvRV (sv)) != SVt_PVMG
      || SvSTASH (SvRV (sv)) != aio_wd_stash)
    croak ("IO::AIO: expected a working directory object as returned by aio_wd");

  return (aio_wd)(long)SvIVX (SvRV (sv));
}

static void
aio_grp_feed (aio_req grp)
{
  if (grp->sv2 && SvOK (grp->sv2))
    {
      dSP;

      ENTER;
      SAVETMPS;
      PUSHMARK (SP);
      XPUSHs (req_sv (grp, aio_grp_stash));
      PUTBACK;
      call_sv (grp->sv2, G_VOID | G_EVAL | G_KEEPERR);
      SPAGAIN;
      FREETMPS;
      LEAVE;
    }
}

static void
req_submit (eio_req *req)
{
  eio_submit (req);

  if (expect_false (on_next_submit))
    {
      dSP;
      SV *cb = sv_2mortal (on_next_submit);

      on_next_submit = 0;

      PUSHMARK (SP);
      PUTBACK;
      call_sv (cb, G_DISCARD | G_EVAL);
    }
}

static int
req_invoke (eio_req *req)
{
  if (req->flags & FLAG_SV2_RO_OFF)
    SvREADONLY_off (req->sv2);

  if (!EIO_CANCELLED (req) && req->callback)
    {
      dSP;
      static SV *sv_result_cache; /* caches the result integer SV */
      SV *sv_result;

      ENTER;
      SAVETMPS;
      PUSHMARK (SP);
      EXTEND (SP, 1);

      /* do not recreate the result IV from scratch each time */
      if (expect_true (sv_result_cache))
        {
          sv_result = sv_result_cache; sv_result_cache = 0;
          SvIV_set (sv_result, req->result);
          SvIOK_only (sv_result);
        }
      else
        {
          sv_result = newSViv (req->result);
          SvREADONLY_on (sv_result);
        }

      switch (req->type)
        {
          case EIO_WD_OPEN:
            PUSHs (req->result ? &PL_sv_undef : sv_2mortal (newSVaio_wd (req->wd)));
            break;

          case EIO_READDIR:
            {
              SV *rv = &PL_sv_undef;

              if (req->result >= 0)
                {
                  int i;
                  char *names = (char *)req->ptr2;
                  eio_dirent *ent = (eio_dirent *)req->ptr1; /* might be 0 */
                  AV *av = newAV ();

                  av_extend (av, req->result - 1);

                  for (i = 0; i < req->result; ++i)
                    {
                      if (req->int1 & EIO_READDIR_DENTS)
                        {
                          SV *namesv = newSVpvn (names + ent->nameofs, ent->namelen);

                          if (req->int1 & EIO_READDIR_CUSTOM2)
                            {
                              static SV *sv_type [EIO_DT_MAX + 1]; /* type sv cache */
                              AV *avent = newAV ();

                              av_extend (avent, 2);

                              if (!sv_type [ent->type])
                                {
                                  sv_type [ent->type] = newSViv (ent->type);
                                  SvREADONLY_on (sv_type [ent->type]);
                                }

                              av_store (avent, 0, namesv);
                              av_store (avent, 1, SvREFCNT_inc (sv_type [ent->type]));
                              av_store (avent, 2, IVSIZE >= 8 ? newSVuv (ent->inode) : newSVnv (ent->inode));

                              av_store (av, i, newRV_noinc ((SV *)avent));
                            }
                          else
                            av_store (av, i, namesv);

                          ++ent;
                        }
                      else
                        {
                          SV *name = newSVpv (names, 0);
                          av_store (av, i, name);
                          names += SvCUR (name) + 1;
                        }
                    }

                  rv = sv_2mortal (newRV_noinc ((SV *)av));
                }

              PUSHs (rv);

              if (req->int1 & EIO_READDIR_CUSTOM1)
                XPUSHs (sv_2mortal (newSViv (req->int1 & ~(EIO_READDIR_CUSTOM1 | EIO_READDIR_CUSTOM2))));
            }
            break;

          case EIO_OPEN:
            {
              /* convert fd to fh */
              SV *fh = &PL_sv_undef;

              if (req->result >= 0)
                {
                  GV *gv = (GV *)sv_newmortal ();
                  int flags = req->int1 & (O_RDONLY | O_WRONLY | O_RDWR);
                  char sym [64];
                  int symlen;
                  
                  symlen = snprintf (sym, sizeof (sym), "fd#%d", (int)req->result);
                  gv_init (gv, aio_stash, sym, symlen, 0);

                  symlen = snprintf (
                     sym,
                     sizeof (sym),
                     "%s&=%d",
                     flags == O_RDONLY ? "<" : flags == O_WRONLY ? ">" : "+<",
                     (int)req->result
                  );

                  if (do_open (gv, sym, symlen, 0, 0, 0, 0))
                    fh = (SV *)gv;
                }

              PUSHs (fh);
            }
            break;

          case EIO_STATVFS:
          case EIO_FSTATVFS:
            {
              SV *rv = &PL_sv_undef;
             
#ifndef _WIN32
              if (req->result >= 0)
                {
                  EIO_STRUCT_STATVFS *f = EIO_STATVFS_BUF (req);
                  HV *hv = newHV ();

                  rv = sv_2mortal (newRV_noinc ((SV *)hv));

                  hv_store (hv, "bsize"  , sizeof ("bsize"  ) - 1, newSVval64 (f->f_bsize  ), 0);
                  hv_store (hv, "frsize" , sizeof ("frsize" ) - 1, newSVval64 (f->f_frsize ), 0);
                  hv_store (hv, "blocks" , sizeof ("blocks" ) - 1, newSVval64 (f->f_blocks ), 0);
                  hv_store (hv, "bfree"  , sizeof ("bfree"  ) - 1, newSVval64 (f->f_bfree  ), 0);
                  hv_store (hv, "bavail" , sizeof ("bavail" ) - 1, newSVval64 (f->f_bavail ), 0);
                  hv_store (hv, "files"  , sizeof ("files"  ) - 1, newSVval64 (f->f_files  ), 0);
                  hv_store (hv, "ffree"  , sizeof ("ffree"  ) - 1, newSVval64 (f->f_ffree  ), 0);
                  hv_store (hv, "favail" , sizeof ("favail" ) - 1, newSVval64 (f->f_favail ), 0);
                  hv_store (hv, "fsid"   , sizeof ("fsid"   ) - 1, newSVval64 (f->f_fsid   ), 0);
                  hv_store (hv, "flag"   , sizeof ("flag"   ) - 1, newSVval64 (f->f_flag   ), 0);
                  hv_store (hv, "namemax", sizeof ("namemax") - 1, newSVval64 (f->f_namemax), 0);
                }
#endif

              PUSHs (rv);
            }

            break;

          case EIO_GROUP:
            req->int1 = 2; /* mark group as finished */

            if (req->sv1)
              {
                int i;
                AV *av = (AV *)req->sv1;

                EXTEND (SP, AvFILL (av) + 1);
                for (i = 0; i <= AvFILL (av); ++i)
                  PUSHs (*av_fetch (av, i, 0));
              }
            break;

          case EIO_NOP:
          case EIO_BUSY:
            break;

          case EIO_READLINK:
          case EIO_REALPATH:
            if (req->result > 0)
              PUSHs (sv_2mortal (newSVpvn (req->ptr2, req->result)));
            break;

          case EIO_STAT:
          case EIO_LSTAT:
          case EIO_FSTAT:
            PL_laststype = req->type == EIO_LSTAT ? OP_LSTAT : OP_STAT;

            if (!(PL_laststatval = req->result))
              /* if compilation fails here then perl's Stat_t is not struct _stati64 */
              PL_statcache = *(EIO_STRUCT_STAT *)(req->ptr2);

            PUSHs (sv_result);
            break;

          case EIO_SEEK:
            PUSHs (req->result ? sv_result : sv_2mortal (newSVval64 (req->offs)));
            break;

          case EIO_READ:
            {
              SvCUR_set (req->sv2, req->stroffset + (req->result > 0 ? req->result : 0));
              *SvEND (req->sv2) = 0;
              SvPOK_only (req->sv2);
              SvSETMAGIC (req->sv2);
              PUSHs (sv_result);
            }
            break;

          case EIO_CUSTOM:
            if (req->feed == fiemap)
              {
#if HAVE_FIEMAP
                if (!req->result)
                  {
                    struct fiemap *fiemap = (struct fiemap *)req->ptr1;

                    if (fiemap->fm_extent_count)
                      {
                        AV *av = newAV ();
                        int i;

                        while (fiemap->fm_mapped_extents)
                          {
                            struct fiemap_extent *extent = &fiemap->fm_extents [--fiemap->fm_mapped_extents];
                            AV *ext_av = newAV ();

                            av_store (ext_av, 3, newSVuv    (extent->fe_flags));
                            av_store (ext_av, 2, newSVval64 (extent->fe_length));
                            av_store (ext_av, 1, newSVval64 (extent->fe_physical));
                            av_store (ext_av, 0, newSVval64 (extent->fe_logical));

                            av_store (av, fiemap->fm_mapped_extents, newRV_noinc ((SV *)ext_av));
                          }

                        PUSHs (sv_2mortal (newRV_noinc ((SV *)av)));
                      }
                    else
                      {
                        SvIV_set (sv_result, fiemap->fm_mapped_extents);
                        PUSHs (sv_result);
                      }
                  }
#endif
              }
            else
              PUSHs (sv_result);
            break;

          case EIO_DUP2: /* EIO_DUP2 actually means aio_close(), so fudge result value */
            if (req->result > 0)
              SvIV_set (sv_result, 0);
            /* FALLTHROUGH */

          default:
            PUSHs (sv_result);
            break;
        }

      errno = req->errorno;

      PUTBACK;
      call_sv (req->callback, G_VOID | G_EVAL | G_DISCARD);
      SPAGAIN;

      if (expect_false (SvREFCNT (sv_result) != 1 || sv_result_cache))
        SvREFCNT_dec (sv_result);
      else
        sv_result_cache = sv_result;

      FREETMPS;
      LEAVE;

      PUTBACK;
    }

  return !!SvTRUE (ERRSV);
}

static void
req_destroy (aio_req req)
{
  if (req->self)
    {
      sv_unmagic (req->self, PERL_MAGIC_ext);
      SvREFCNT_dec (req->self);
    }

  SvREFCNT_dec (req->sv1);
  SvREFCNT_dec (req->sv2);
  SvREFCNT_dec (req->sv3);
  SvREFCNT_dec (req->sv4);
  SvREFCNT_dec (req->callback);

  free (req);
}

static void
req_cancel_subs (aio_req grp)
{
  if (grp->type != EIO_GROUP)
    return;

  SvREFCNT_dec (grp->sv2);
  grp->sv2 = 0;

  eio_grp_cancel (grp);
}

static void ecb_cold
create_respipe (void)
{
  if (s_epipe_renew (&respipe))
    croak ("IO::AIO: unable to initialize result pipe");
}

static void
poll_wait (void)
{
  while (eio_nreqs ())
    {
      int size;

      X_LOCK   (reslock);
      size = res_queue.size;
      X_UNLOCK (reslock);

      if (size)
        return;

      etp_maybe_start_thread ();

      s_epipe_wait (&respipe);
    }
}

static int
poll_cb (void)
{
  for (;;)
    {
      int res = eio_poll ();

      if (res > 0)
        croak (0);

      if (!max_outstanding || max_outstanding > eio_nreqs ())
        return res;

      poll_wait ();
    }
}

static void ecb_cold
reinit (void)
{
  create_respipe ();

  if (eio_init (want_poll, done_poll) < 0)
    croak ("IO::AIO: unable to initialise eio library");
}

/*****************************************************************************/

#if !_POSIX_MAPPED_FILES
# define mmap(addr,length,prot,flags,fd,offs) EIO_ENOSYS ()
# define munmap(addr,length)                  EIO_ENOSYS ()
#endif

#if !_POSIX_MEMORY_PROTECTION
# define mprotect(addr,len,prot)              EIO_ENOSYS ()
# define PROT_NONE   0
# define PROT_WRITE  0
# define MAP_PRIVATE 0
# define MAP_SHARED  0
# define MAP_FIXED   0
#endif

#define MMAP_MAGIC PERL_MAGIC_ext

static int ecb_cold
mmap_free (pTHX_ SV *sv, MAGIC *mg)
{
  int old_errno = errno;
  munmap (mg->mg_ptr, (size_t)mg->mg_obj);
  errno = old_errno;

  mg->mg_obj = 0; /* just in case */

  SvREADONLY_off (sv);

  if (SvPVX (sv) != mg->mg_ptr)
    croak ("ERROR: IO::AIO::mmap-mapped scalar changed location, detected");

  SvCUR_set (sv, 0);
  SvPVX (sv) = 0;
  SvOK_off (sv);

  return 0;
}

static MGVTBL mmap_vtbl = {
  0, 0, 0, 0, mmap_free
};

/*****************************************************************************/

static SV *
get_cb (SV *cb_sv)
{
  SvGETMAGIC (cb_sv);
  return SvOK (cb_sv) ? s_get_cv_croak (cb_sv) : 0;
}

static aio_req ecb_noinline
dreq (SV *callback)
{
  SV *cb_cv;
  aio_req req;
  int req_pri = next_pri;
  next_pri = EIO_PRI_DEFAULT;

  cb_cv = get_cb (callback);

  req = calloc (sizeof (*req), 1);
  if (!req)
    croak ("out of memory during eio_req allocation");

  req->callback = SvREFCNT_inc (cb_cv);
  req->pri = req_pri;

  return req;
}

#define dREQ							\
  aio_req req = dreq (callback);				\

#define REQ_SEND						\
  PUTBACK;							\
  req_submit (req);						\
  SPAGAIN;							\
								\
  if (GIMME_V != G_VOID)					\
    XPUSHs (req_sv (req, aio_req_stash));

ecb_inline void
req_set_path (aio_req req, SV *path, SV **wdsv, SV **pathsv, eio_wd *wd, void **ptr)
{
  if (expect_false (SvROK (path)))
    {
      SV *rv = SvRV (path);
      SV *wdob;

      if (SvTYPE (rv) == SVt_PVAV && AvFILLp (rv) == 1)
        {
          path = AvARRAY (rv)[1];
          wdob = AvARRAY (rv)[0];

          if (SvOK (wdob))
            {
              *wd = SvAIO_WD (wdob);
              *wdsv = SvREFCNT_inc_NN (SvRV (wdob));
            }
          else
            *wd = EIO_INVALID_WD;
        }
      else if (SvTYPE (rv) == SVt_PVMG && SvSTASH (rv) == aio_wd_stash)
        {
          *wd = (aio_wd)(long)SvIVX (rv);
          *wdsv = SvREFCNT_inc_NN (rv);
          *ptr = ".";
          return; /* path set to "." */
        }
      else
        croak ("IO::AIO: pathname arguments must be specified as a string, an IO::AIO::WD object or a [IO::AIO::WD, path] pair");
    }

  *pathsv = newSVsv (path);
  *ptr = SvPVbyte_nolen (*pathsv);
}

static void ecb_noinline
req_set_path1 (aio_req req, SV *path)
{
  req_set_path (req, path, &req->sv1, &req->sv3, &req->wd, &req->ptr1);
}

static void ecb_noinline
req_set_fh_or_path (aio_req req, int type_path, int type_fh, SV *fh_or_path)
{
  SV *rv = SvROK (fh_or_path) ? SvRV (fh_or_path) : fh_or_path;

  switch (SvTYPE (rv))
    {
      case SVt_PVIO:
      case SVt_PVLV:
      case SVt_PVGV:
        req->type = type_fh;
        req->sv1  = newSVsv (fh_or_path);
        req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh_or_path)));
        break;

      default:
        req->type = type_path;
        req_set_path1 (req, fh_or_path);
        break;
    }
}

XS(boot_IO__AIO) ecb_cold;

#line 859 "AIO.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 1001 "AIO.c"

XS_EUPXS(XS_IO__AIO_reinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_reinit)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	reinit();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_max_poll_reqs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_max_poll_reqs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nreqs");
    {
	unsigned int	nreqs = (unsigned int)SvUV(ST(0))
;
#line 1026 "AIO.xs"
        eio_set_max_poll_reqs (nreqs);
#line 1028 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_max_poll_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_max_poll_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nseconds");
    {
	double	nseconds = (double)SvNV(ST(0))
;
#line 1032 "AIO.xs"
        eio_set_max_poll_time (nseconds);
#line 1045 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_min_parallel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_min_parallel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nthreads");
    {
	unsigned int	nthreads = (unsigned int)SvUV(ST(0))
;
#line 1038 "AIO.xs"
        eio_set_min_parallel (nthreads);
#line 1062 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_max_parallel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_max_parallel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nthreads");
    {
	unsigned int	nthreads = (unsigned int)SvUV(ST(0))
;
#line 1044 "AIO.xs"
        eio_set_max_parallel (nthreads);
#line 1079 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_max_idle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_max_idle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nthreads");
    {
	unsigned int	nthreads = (unsigned int)SvUV(ST(0))
;
#line 1050 "AIO.xs"
        eio_set_max_idle (nthreads);
#line 1096 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_idle_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_idle_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seconds");
    {
	unsigned int	seconds = (unsigned int)SvUV(ST(0))
;
#line 1056 "AIO.xs"
        eio_set_idle_timeout (seconds);
#line 1113 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_max_outstanding); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_max_outstanding)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "maxreqs");
    {
	unsigned int	maxreqs = (unsigned int)SvUV(ST(0))
;
#line 1062 "AIO.xs"
        max_outstanding = maxreqs;
#line 1130 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_aio_wd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_wd)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pathname, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1067 "AIO.xs"
{
        dREQ;

        req->type = EIO_WD_OPEN;
        req_set_path1 (req, pathname);

        REQ_SEND;
}
#line 1168 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_open)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "pathname, flags, mode, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	int	flags = (int)SvIV(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1079 "AIO.xs"
{
        dREQ;

        req->type = EIO_OPEN;
        req_set_path1 (req, pathname);
        req->int1 = flags;
        req->int2 = mode;

        REQ_SEND;
}
#line 1213 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_fsync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_fsync)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "fh, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1097 "AIO.xs"
{
  	int fd = s_fileno_croak (fh, 0);
        dREQ;

        req->type = ix;
        req->sv1  = newSVsv (fh);
        req->int1 = fd;

        REQ_SEND;
}
#line 1251 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_sync_file_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_sync_file_range)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "fh, offset, nbytes, flags, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	off_t	offset = (off_t)SvVAL64 (ST(1))
;
	size_t	nbytes = (size_t)SvVAL64 (ST(2))
;
	UV	flags = (UV)SvUV(ST(3))
;
	SV *	callback;

	if (items < 5)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(4)
;
	}
#line 1111 "AIO.xs"
{
  	int fd = s_fileno_croak (fh, 0);
        dREQ;

        req->type = EIO_SYNC_FILE_RANGE;
        req->sv1  = newSVsv (fh);
        req->int1 = fd;
        req->offs = offset;
        req->size = nbytes;
        req->int2 = flags;

        REQ_SEND;
}
#line 1297 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_fallocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_fallocate)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "fh, mode, offset, len, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	int	mode = (int)SvIV(ST(1))
;
	off_t	offset = (off_t)SvVAL64 (ST(2))
;
	size_t	len = (size_t)SvVAL64 (ST(3))
;
	SV *	callback;

	if (items < 5)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(4)
;
	}
#line 1128 "AIO.xs"
{
  	int fd = s_fileno_croak (fh, 0);
        dREQ;

        req->type = EIO_FALLOCATE;
        req->sv1  = newSVsv (fh);
        req->int1 = fd;
        req->int2 = mode;
        req->offs = offset;
        req->size = len;

        REQ_SEND;
}
#line 1343 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "fh, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1145 "AIO.xs"
{
        static int close_fd = -1; /* dummy fd to close fds via dup2 */
  	int fd = s_fileno_croak (fh, 0);
        dREQ;

        if (expect_false (close_fd < 0))
          {
            int pipefd [2];

            if (
#ifdef _WIN32
              _pipe (pipefd, 1, _O_BINARY) < 0
#else
              pipe (pipefd) < 0
              || fcntl (pipefd [0], F_SETFD, FD_CLOEXEC) < 0
#endif
              || close (pipefd [1]) < 0
            )
              abort (); /*D*/

            close_fd = pipefd [0];
          }

        req->type = EIO_DUP2;
        req->int1 = close_fd;
        req->sv2  = newSVsv (fh);
        req->int2 = fd;

        REQ_SEND;
}
#line 1400 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_seek)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "fh, offset, whence, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	SV *	offset = ST(1)
;
	int	whence = (int)SvIV(ST(2))
;
	SV *	callback;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1179 "AIO.xs"
{
        int fd = s_fileno_croak (fh, 0);
        dREQ;

        req->type = EIO_SEEK;
        req->sv1  = newSVsv (fh);
        req->int1 = fd;
        req->offs = SvVAL64 (offset);
        req->int2 = whence;

        REQ_SEND;
}
#line 1443 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_read)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "fh, offset, length, data, dataoffset, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	SV *	offset = ST(1)
;
	SV *	length = ST(2)
;
	SV8 *	data;
	IV	dataoffset = (IV)SvIV(ST(4))
;
	SV *	callback;

	(data) = ST(3);
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "data")
;

	if (items < 6)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(5)
;
	}
#line 1198 "AIO.xs"
{
        STRLEN svlen;
        int fd = s_fileno_croak (fh, ix == EIO_WRITE);
        char *svptr = SvPVbyte (data, svlen);
        UV len = SvUV (length);

        if (dataoffset < 0)
          dataoffset += svlen;

        if (dataoffset < 0 || dataoffset > svlen)
          croak ("dataoffset outside of data scalar");

        if (ix == EIO_WRITE)
          {
            /* write: check length and adjust. */
            if (!SvOK (length) || len + dataoffset > svlen)
              len = svlen - dataoffset;
          }
        else
          {
            /* read: check type and grow scalar as necessary */
            SvUPGRADE (data, SVt_PV);
            svptr = SvGROW (data, len + dataoffset + 1);
          }

        {
          dREQ;

          req->type = ix;
          req->sv1  = newSVsv (fh);
          req->int1 = fd;
          req->offs = SvOK (offset) ? SvVAL64 (offset) : -1;
          req->size = len;
          req->sv2  = SvREFCNT_inc (data);
          req->ptr2 = (char *)svptr + dataoffset;
          req->stroffset = dataoffset;

          if (!SvREADONLY (data))
            {
              SvREADONLY_on (data);
              req->flags |= FLAG_SV2_RO_OFF;
            }

          REQ_SEND;
        }
}
#line 1529 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_readlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_readlink)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pathname, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1251 "AIO.xs"
{
        dREQ;

        req->type = ix;
        req_set_path1 (req, pathname);

        REQ_SEND;
}
#line 1569 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_sendfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_sendfile)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "out_fh, in_fh, in_offset, length, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	out_fh = ST(0)
;
	SV *	in_fh = ST(1)
;
	off_t	in_offset = (off_t)SvVAL64 (ST(2))
;
	size_t	length = (size_t)SvVAL64 (ST(3))
;
	SV *	callback;

	if (items < 5)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(4)
;
	}
#line 1263 "AIO.xs"
{
  	int ifd = s_fileno_croak (in_fh , 0);
  	int ofd = s_fileno_croak (out_fh, 1);
	dREQ;

        req->type = EIO_SENDFILE;
        req->sv1  = newSVsv (out_fh);
        req->int1 = ofd;
        req->sv2  = newSVsv (in_fh);
        req->int2 = ifd;
        req->offs = in_offset;
        req->size = length;

        REQ_SEND;
}
#line 1617 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_readahead); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_readahead)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "fh, offset, length, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	off_t	offset = (off_t)SvVAL64 (ST(1))
;
	size_t	length = (size_t)SvVAL64 (ST(2))
;
	SV *	callback;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1282 "AIO.xs"
{
  	int fd = s_fileno_croak (fh, 0);
	dREQ;

        req->type = EIO_READAHEAD;
        req->sv1  = newSVsv (fh);
        req->int1 = fd;
        req->offs = offset;
        req->size = length;

        REQ_SEND;
}
#line 1660 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_stat)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "fh_or_path, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path")
;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1302 "AIO.xs"
{
	dREQ;

        req_set_fh_or_path (req, ix, ix == EIO_STATVFS ? EIO_FSTATVFS : EIO_FSTAT, fh_or_path);

        REQ_SEND;
}
#line 1699 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_major); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_major)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	UV	RETVAL;
	dXSTARG;
	UV	dev = (UV)SvUV(ST(0))
;
#line 1315 "AIO.xs"
        RETVAL = ix ? major (dev) : minor (dev);
#line 1720 "AIO.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_makedev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_makedev)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "maj, min");
    {
	UV	RETVAL;
	dXSTARG;
	UV	maj = (UV)SvUV(ST(0))
;
	UV	min = (UV)SvUV(ST(1))
;
#line 1322 "AIO.xs"
        RETVAL = makedev (maj, min);
#line 1742 "AIO.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_aio_utime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_utime)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "fh_or_path, atime, mtime, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	atime = ST(1)
;
	SV *	mtime = ST(2)
;
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path")
;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1329 "AIO.xs"
{
	dREQ;

        req->nv1 = SvOK (atime) ? SvNV (atime) : -1.;
        req->nv2 = SvOK (mtime) ? SvNV (mtime) : -1.;
        req_set_fh_or_path (req, EIO_UTIME, EIO_FUTIME, fh_or_path);

        REQ_SEND;
}
#line 1786 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_truncate)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "fh_or_path, offset, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	offset = ST(1)
;
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path")
;

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2)
;
	}
#line 1342 "AIO.xs"
{
	dREQ;

        req->offs = SvOK (offset) ? SvVAL64 (offset) : -1;
        req_set_fh_or_path (req, EIO_TRUNCATE, EIO_FTRUNCATE, fh_or_path);

        REQ_SEND;
}
#line 1827 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_chmod)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "fh_or_path, mode, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	int	mode = (int)SvIV(ST(1))
;
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path")
;

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2)
;
	}
#line 1354 "AIO.xs"
{
	dREQ;

        req->int2 = mode;
        req_set_fh_or_path (req, EIO_CHMOD, EIO_FCHMOD, fh_or_path);

        REQ_SEND;
}
#line 1868 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_chown)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "fh_or_path, uid, gid, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	uid = ST(1)
;
	SV *	gid = ST(2)
;
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path")
;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1366 "AIO.xs"
{
	dREQ;

        req->int2 = SvOK (uid) ? SvIV (uid) : -1;
        req->int3 = SvOK (gid) ? SvIV (gid) : -1;
        req_set_fh_or_path (req, EIO_CHOWN, EIO_FCHOWN, fh_or_path);

        REQ_SEND;
}
#line 1912 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_readdirx); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_readdirx)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pathname, flags, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	IV	flags = (IV)SvIV(ST(1))
;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2)
;
	}
#line 1379 "AIO.xs"
{
	dREQ;

        req->type = EIO_READDIR;
        req->int1 = flags | EIO_READDIR_DENTS | EIO_READDIR_CUSTOM1;

        if (flags & EIO_READDIR_DENTS)
          req->int1 |= EIO_READDIR_CUSTOM2;

        req_set_path1 (req, pathname);

	REQ_SEND;
}
#line 1958 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_mkdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_mkdir)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pathname, mode, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	int	mode = (int)SvIV(ST(1))
;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2)
;
	}
#line 1396 "AIO.xs"
{
	dREQ;

        req->type = EIO_MKDIR;
        req->int2 = mode;
        req_set_path1 (req, pathname);

        REQ_SEND;
}
#line 2000 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_unlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_unlink)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pathname, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1413 "AIO.xs"
{
	dREQ;

        req->type = ix;
        req_set_path1 (req, pathname);

	REQ_SEND;
}
#line 2040 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_link); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_link)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "oldpath, newpath, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	oldpath;
	SV8 *	newpath;
	SV *	callback;

	(oldpath) = ST(0);
        if (SvPOKp (oldpath) && !sv_utf8_downgrade (oldpath, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "oldpath")
;

	(newpath) = ST(1);
        if (SvPOKp (newpath) && !sv_utf8_downgrade (newpath, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "newpath")
;

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2)
;
	}
#line 1429 "AIO.xs"
{
        eio_wd wd2 = 0;
	dREQ;

        req->type = ix;
        req_set_path1 (req, oldpath);
        req_set_path (req, newpath, &req->sv2, &req->sv4, &wd2, &req->ptr2);
        req->int3 = (long)wd2;

	REQ_SEND;
}
#line 2089 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_mknod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_mknod)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "pathname, mode, dev, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	int	mode = (int)SvIV(ST(1))
;
	UV	dev = (UV)SvUV(ST(2))
;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname")
;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1444 "AIO.xs"
{
	dREQ;

        req->type = EIO_MKNOD;
        req->int2 = (mode_t)mode;
        req->offs = dev;
        req_set_path1 (req, pathname);

	REQ_SEND;
}
#line 2134 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_mtouch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_mtouch)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "data, offset= 0, length= &PL_sv_undef, flags= 0, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	data;
	IV	offset;
	SV *	length;
	int	flags;
	SV *	callback;

	(data) = ST(0);
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "data")
;

	if (items < 2)
	    offset = 0;
	else {
	    offset = (IV)SvIV(ST(1))
;
	}

	if (items < 3)
	    length = &PL_sv_undef;
	else {
	    length = ST(2)
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(4)
;
	}
#line 1461 "AIO.xs"
{
        STRLEN svlen;
        char *svptr = SvPVbyte (data, svlen);
        UV len = SvUV (length);

        if (offset < 0)
          offset += svlen;

        if (offset < 0 || offset > svlen)
          croak ("offset outside of scalar");

        if (!SvOK (length) || len + offset > svlen)
          len = svlen - offset;

        {
          dREQ;

          req->type = ix;
          req->sv2  = SvREFCNT_inc (data);
          req->ptr2 = (char *)svptr + offset;
          req->size = len;
          req->int1 = flags;

          REQ_SEND;
        }
}
#line 2216 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_mlock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_mlock)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "data, offset= 0, length= &PL_sv_undef, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	data;
	IV	offset;
	SV *	length;
	SV *	callback;

	(data) = ST(0);
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "data")
;

	if (items < 2)
	    offset = 0;
	else {
	    offset = (IV)SvIV(ST(1))
;
	}

	if (items < 3)
	    length = &PL_sv_undef;
	else {
	    length = ST(2)
;
	}

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1491 "AIO.xs"
{
        STRLEN svlen;
        char *svptr = SvPVbyte (data, svlen);
        UV len = SvUV (length);

        if (offset < 0)
          offset += svlen;

        if (offset < 0 || offset > svlen)
          croak ("offset outside of scalar");

        if (!SvOK (length) || len + offset > svlen)
          len = svlen - offset;

        {
          dREQ;

          req->type = EIO_MLOCK;
          req->sv2  = SvREFCNT_inc (data);
          req->ptr2 = (char *)svptr + offset;
          req->size = len;

          REQ_SEND;
        }
}
#line 2288 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_mlockall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_mlockall)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "flags, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	flags = (IV)SvIV(ST(0))
;
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1520 "AIO.xs"
{
        dREQ;

        req->type = EIO_MLOCKALL;
        req->int1 = flags;

        REQ_SEND;
}
#line 2323 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_fiemap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_fiemap)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "fh, start, length, flags, count, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0)
;
	off_t	start = (off_t)SvVAL64 (ST(1))
;
	SV *	length = ST(2)
;
	U32	flags = (unsigned long)SvUV(ST(3))
;
	SV *	count = ST(4)
;
	SV *	callback;

	if (items < 6)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(5)
;
	}
#line 1532 "AIO.xs"
{
  	int fd = s_fileno_croak (fh, 0);
	dREQ;

        req->type = EIO_CUSTOM;
        req->sv1  = newSVsv (fh);
        req->int1 = fd;

        req->feed = fiemap;
#if HAVE_FIEMAP
        /* keep our fingers crossed that the next two types are 64 bit */
        req->offs = start;
        req->size = SvOK (length) ? SvVAL64 (length) : ~0ULL;
        req->int2 = flags;
        req->int3 = SvOK (count) ? SvIV (count) : -1;
#endif

	REQ_SEND;
}
#line 2377 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_busy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_busy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "delay, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	double	delay = (double)SvNV(ST(0))
;
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1555 "AIO.xs"
{
	dREQ;

        req->type = EIO_BUSY;
        req->nv1  = delay < 0. ? 0. : delay;

	REQ_SEND;
}
#line 2412 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_group); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_group)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	callback;

	if (items < 1)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(0)
;
	}
#line 1567 "AIO.xs"
{
	dREQ;

        req->type = EIO_GROUP;

        req_submit (req);
        XPUSHs (req_sv (req, aio_grp_stash));
}
#line 2445 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aio_nop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aio_nop)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	callback;

	if (items < 1)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(0)
;
	}
#line 1582 "AIO.xs"
{
	dREQ;

        req->type = ix;

	REQ_SEND;
}
#line 2478 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_aioreq_pri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aioreq_pri)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "pri= 0");
    {
	int	RETVAL;
	dXSTARG;
	int	pri;

	if (items < 1)
	    pri = 0;
	else {
	    pri = (int)SvIV(ST(0))
;
	}
#line 1593 "AIO.xs"
	RETVAL = next_pri;
	if (items > 0)
	  {
	    if (pri < EIO_PRI_MIN) pri = EIO_PRI_MIN;
	    if (pri > EIO_PRI_MAX) pri = EIO_PRI_MAX;
	    next_pri = pri;
	  }
#line 2510 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_aioreq_nice); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_aioreq_nice)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "nice= 0");
    {
	int	nice;

	if (items < 1)
	    nice = 0;
	else {
	    nice = (int)SvIV(ST(0))
;
	}
#line 1606 "AIO.xs"
	nice = next_pri - nice;
	if (nice < EIO_PRI_MIN) nice = EIO_PRI_MIN;
	if (nice > EIO_PRI_MAX) nice = EIO_PRI_MAX;
	next_pri = nice;
#line 2537 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_flush)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1614 "AIO.xs"
        while (eio_nreqs ())
          {
            poll_wait ();
            poll_cb ();
          }
#line 2556 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_poll)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1623 "AIO.xs"
        poll_wait ();
        RETVAL = poll_cb ();
#line 2574 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_poll_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_poll_fileno)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1631 "AIO.xs"
        RETVAL = s_epipe_fd (&respipe);
#line 2592 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_poll_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_poll_cb)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1639 "AIO.xs"
        RETVAL = poll_cb ();
#line 2609 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_poll_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_poll_wait)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1646 "AIO.xs"
        poll_wait ();
#line 2625 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_nreqs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_nreqs)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1651 "AIO.xs"
        RETVAL = eio_nreqs ();
#line 2642 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_nready); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_nready)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1658 "AIO.xs"
        RETVAL = eio_nready ();
#line 2660 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_npending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_npending)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1665 "AIO.xs"
        RETVAL = eio_npending ();
#line 2678 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_nthreads); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_nthreads)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1672 "AIO.xs"
        RETVAL = eio_nthreads ();
#line 2696 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_fadvise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_fadvise)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fh, offset, length, advice");
    {
	int	RETVAL;
	dXSTARG;
	aio_rfd  	fh = s_fileno_croak (ST(0), 0)
;
	off_t	offset = (off_t)SvVAL64 (ST(1))
;
	off_t	length = (off_t)SvVAL64 (ST(2))
;
	IV	advice = (IV)SvIV(ST(3))
;
#line 1679 "AIO.xs"
        RETVAL = posix_fadvise (fh, offset, length, advice);
#line 2722 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_sendfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_sendfile)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ofh, ifh, offset, count");
    {
	IV	RETVAL;
	dXSTARG;
	aio_wfd  	ofh = s_fileno_croak (ST(0), 1)
;
	aio_rfd  	ifh = s_fileno_croak (ST(1), 0)
;
	off_t	offset = (off_t)SvVAL64 (ST(2))
;
	size_t	count = (size_t)SvVAL64 (ST(3))
;
#line 1686 "AIO.xs"
        RETVAL = eio_sendfile_sync (ofh, ifh, offset, count);
#line 2748 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_mmap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_mmap)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "scalar, length, prot, flags, fh, offset= 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	scalar = ST(0)
;
	size_t	length = (size_t)SvVAL64 (ST(1))
;
	int	prot = (int)SvIV(ST(2))
;
	int	flags = (int)SvIV(ST(3))
;
	SV *	fh = ST(4)
;
	off_t	offset;

	if (items < 6)
	    offset = 0;
	else {
	    offset = (off_t)SvVAL64 (ST(5))
;
	}
#line 1693 "AIO.xs"
        sv_unmagic (scalar, MMAP_MAGIC);
{
        int fd = SvOK (fh) ? s_fileno_croak (fh, flags & PROT_WRITE) : -1;
        void *addr = (void *)mmap (0, length, prot, flags, fd, offset);
	if (addr == (void *)-1)
	  XSRETURN_NO;

        sv_force_normal (scalar);

        /* we store the length in mg_obj, as namlen is I32 :/ */
        sv_magicext (scalar, 0, MMAP_MAGIC, &mmap_vtbl, (char *)addr, 0)
          ->mg_obj = (SV *)length;

	SvUPGRADE (scalar, SVt_PV); /* nop... */

	if (!(prot & PROT_WRITE))
	  SvREADONLY_on (scalar);

        if (SvLEN (scalar))
          Safefree (SvPVX (scalar));

	SvPVX (scalar) = (char *)addr;
	SvCUR_set (scalar, length);
	SvLEN_set (scalar, 0);
	SvPOK_only (scalar);

        XSRETURN_YES;
}
#line 2811 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO_munmap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_munmap)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "scalar");
    {
	SV *	scalar = ST(0)
;
#line 1725 "AIO.xs"
        sv_unmagic (scalar, MMAP_MAGIC);
#line 2829 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO_madvise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_madvise)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "scalar, offset= 0, length= &PL_sv_undef, advice_or_prot");
    {
	int	RETVAL;
	dXSTARG;
	SV *	scalar = ST(0)
;
	off_t	offset;
	SV *	length;
	IV	advice_or_prot = (IV)SvIV(ST(3))
;

	if (items < 2)
	    offset = 0;
	else {
	    offset = (off_t)SvVAL64 (ST(1))
;
	}

	if (items < 3)
	    length = &PL_sv_undef;
	else {
	    length = ST(2)
;
	}
#line 1732 "AIO.xs"
{
	STRLEN svlen;
  	void *addr = SvPVbyte (scalar, svlen);
        size_t len = SvUV (length);

        if (offset < 0)
          offset += svlen;

        if (offset < 0 || offset > svlen)
          croak ("offset outside of scalar");

        if (!SvOK (length) || len + offset > svlen)
          len = svlen - offset;

        addr = (void *)(((intptr_t)addr) + offset);
        eio_page_align (&addr, &len);

        switch (ix)
          {
            case 0: RETVAL = posix_madvise (addr, len, advice_or_prot); break;
            case 1: RETVAL = mprotect      (addr, len, advice_or_prot); break;
          }
}
#line 2889 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_munlock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_munlock)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "scalar, offset= 0, length= &PL_sv_undef");
    {
	int	RETVAL;
	dXSTARG;
	SV *	scalar = ST(0)
;
	off_t	offset;
	SV *	length;

	if (items < 2)
	    offset = 0;
	else {
	    offset = (off_t)SvVAL64 (ST(1))
;
	}

	if (items < 3)
	    length = &PL_sv_undef;
	else {
	    length = ST(2)
;
	}
#line 1761 "AIO.xs"
{
	STRLEN svlen;
  	void *addr = SvPVbyte (scalar, svlen);
        size_t len = SvUV (length);

        if (offset < 0)
          offset += svlen;

        if (offset < 0 || offset > svlen)
          croak ("offset outside of scalar");

        if (!SvOK (length) || len + offset > svlen)
          len = svlen - offset;

        addr = (void *)(((intptr_t)addr) + offset);
        eio_page_align (&addr, &len);
#if _POSIX_MEMLOCK_RANGE
        RETVAL = munlock (addr, len);
#else
        RETVAL = EIO_ENOSYS ();
#endif
}
#line 2946 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_munlockall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_munlockall)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1789 "AIO.xs"
#if _POSIX_MEMLOCK
        munlockall ();
#else
        RETVAL = EIO_ENOSYS ();
#endif
#line 2968 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_splice); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_splice)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "rfh, off_in, wfh, off_out, length, flags");
    {
	int	RETVAL;
	dXSTARG;
	aio_rfd  	rfh = s_fileno_croak (ST(0), 0)
;
	SV *	off_in = ST(1)
;
	aio_wfd  	wfh = s_fileno_croak (ST(2), 1)
;
	SV *	off_out = ST(3)
;
	size_t	length = (size_t)SvVAL64 (ST(4))
;
	unsigned int	flags = (unsigned int)SvUV(ST(5))
;
#line 1800 "AIO.xs"
{
#if HAVE_LINUX_SPLICE
	loff_t off_in_, off_out_;
        RETVAL = splice (
          rfh, SvOK (off_in ) ? (off_in_  = SvVAL64 (off_in )), &off_in_  : 0,
          wfh, SvOK (off_out) ? (off_out_ = SvVAL64 (off_out)), &off_out_ : 0,
          length, flags
        );
#else
        RETVAL = EIO_ENOSYS ();
#endif
}
#line 3009 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO_tee); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO_tee)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rfh, wfh, length, flags");
    {
	int	RETVAL;
	dXSTARG;
	aio_rfd  	rfh = s_fileno_croak (ST(0), 0)
;
	aio_wfd  	wfh = s_fileno_croak (ST(1), 1)
;
	size_t	length = (size_t)SvVAL64 (ST(2))
;
	unsigned int	flags = (unsigned int)SvUV(ST(3))
;
#line 1818 "AIO.xs"
#if HAVE_LINUX_SPLICE
        RETVAL = tee (rfh, wfh, length, flags);
#else
        RETVAL = EIO_ENOSYS ();
#endif
#line 3039 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__AIO__on_next_submit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__on_next_submit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	SV *	cb = ST(0)
;
#line 1828 "AIO.xs"
        SvREFCNT_dec (on_next_submit);
        on_next_submit = SvOK (cb) ? newSVsv (cb) : 0;
#line 3058 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__WD_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__WD_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1844 "AIO.xs"
{
	aio_wd wd = SvAIO_WD (self);
#if HAVE_AT
        {
          SV *callback = &PL_sv_undef;
          dREQ; /* clobbers next_pri :/ */
          next_pri = req->pri; /* restore next_pri */
          req->pri = EIO_PRI_MAX; /* better use max. priority to conserve fds */
          req->type = EIO_WD_CLOSE;
          req->wd = wd;
          REQ_SEND;
        }
#else
        eio_wd_close_sync (wd);
#endif
}
#line 3090 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__REQ_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__REQ_cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "req");
    {
	aio_req_ornot	req;

	if (!(req = SvAIO_REQ (ST(0))))
	  XSRETURN_EMPTY
;
#line 1866 "AIO.xs"
        eio_cancel (req);
#line 3110 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__REQ_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__REQ_cb)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "req, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	aio_req_ornot	req;
	SV *	callback;

	if (!(req = SvAIO_REQ (ST(0))))
	  XSRETURN_EMPTY
;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1871 "AIO.xs"
{
        if (GIMME_V != G_VOID)
          XPUSHs (req->callback ? sv_2mortal (newRV_inc (req->callback)) : &PL_sv_undef);

        if (items > 1)
          {
            SV *cb_cv =get_cb (callback);

            SvREFCNT_dec (req->callback);
            req->callback = SvREFCNT_inc (cb_cv);
          }
}
#line 3151 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO__GRP_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__GRP_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "grp, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	aio_req	grp;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy IO::AIO::REQ object expected")
;
#line 1889 "AIO.xs"
{
	int i;

        if (grp->int1 == 2)
          croak ("cannot add requests to IO::AIO::GRP after the group finished");

	for (i = 1; i < items; ++i )
          {
            aio_req req;

            if (GIMME_V != G_VOID)
              XPUSHs (sv_2mortal (newSVsv (ST (i))));

            req = SvAIO_REQ (ST (i));

            if (req)
              eio_grp_add (grp, req);
          }
}
#line 3192 "AIO.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__AIO__GRP_cancel_subs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__GRP_cancel_subs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "req");
    {
	aio_req_ornot	req;

	if (!(req = SvAIO_REQ (ST(0))))
	  XSRETURN_EMPTY
;
#line 1912 "AIO.xs"
        req_cancel_subs (req);
#line 3213 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__GRP_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__GRP_result)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "grp, ...");
    {
	aio_req	grp;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy IO::AIO::REQ object expected")
;
#line 1917 "AIO.xs"
{
        int i;
        AV *av;

        grp->errorno = errno;

        av = newAV ();
        av_extend (av, items - 1);

        for (i = 1; i < items; ++i )
          av_push (av, newSVsv (ST (i)));

        SvREFCNT_dec (grp->sv1);
        grp->sv1 = (SV *)av;
}
#line 3247 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__GRP_errno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__GRP_errno)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "grp, errorno= errno");
    {
	aio_req	grp;
	int	errorno;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy IO::AIO::REQ object expected")
;

	if (items < 2)
	    errorno = errno;
	else {
	    errorno = (int)SvIV(ST(1))
;
	}
#line 1936 "AIO.xs"
        grp->errorno = errorno;
#line 3275 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__GRP_limit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__GRP_limit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "grp, limit");
    {
	aio_req	grp;
	int	limit = (int)SvIV(ST(1))
;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy IO::AIO::REQ object expected")
;
#line 1941 "AIO.xs"
        eio_grp_limit (grp, limit);
#line 3297 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__AIO__GRP_feed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__AIO__GRP_feed)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "grp, callback=&PL_sv_undef");
    {
	aio_req	grp;
	SV *	callback;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy IO::AIO::REQ object expected")
;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1)
;
	}
#line 1946 "AIO.xs"
{
        SvREFCNT_dec (grp->sv2);
        grp->sv2  = newSVsv (callback);
        grp->feed = aio_grp_feed;

        if (grp->int2 <= 0)
          grp->int2 = 2;

        eio_grp_limit (grp, grp->int2);
}
#line 3334 "AIO.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_IO__AIO); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_IO__AIO)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

    {
        CV * cv;

        (void)newXSproto_portable("IO::AIO::reinit", XS_IO__AIO_reinit, file, "");
        (void)newXSproto_portable("IO::AIO::max_poll_reqs", XS_IO__AIO_max_poll_reqs, file, "$");
        (void)newXSproto_portable("IO::AIO::max_poll_time", XS_IO__AIO_max_poll_time, file, "$");
        (void)newXSproto_portable("IO::AIO::min_parallel", XS_IO__AIO_min_parallel, file, "$");
        (void)newXSproto_portable("IO::AIO::max_parallel", XS_IO__AIO_max_parallel, file, "$");
        (void)newXSproto_portable("IO::AIO::max_idle", XS_IO__AIO_max_idle, file, "$");
        (void)newXSproto_portable("IO::AIO::idle_timeout", XS_IO__AIO_idle_timeout, file, "$");
        (void)newXSproto_portable("IO::AIO::max_outstanding", XS_IO__AIO_max_outstanding, file, "$");
        (void)newXSproto_portable("IO::AIO::aio_wd", XS_IO__AIO_aio_wd, file, "$;$");
        (void)newXSproto_portable("IO::AIO::aio_open", XS_IO__AIO_aio_open, file, "$$$;$");
        cv = newXSproto_portable("IO::AIO::aio_fsync", XS_IO__AIO_aio_fsync, file, "$;$");
        XSANY.any_i32 = EIO_FSYNC;
        cv = newXSproto_portable("IO::AIO::aio_syncfs", XS_IO__AIO_aio_fsync, file, "$;$");
        XSANY.any_i32 = EIO_SYNCFS;
        cv = newXSproto_portable("IO::AIO::aio_fdatasync", XS_IO__AIO_aio_fsync, file, "$;$");
        XSANY.any_i32 = EIO_FDATASYNC;
        (void)newXSproto_portable("IO::AIO::aio_sync_file_range", XS_IO__AIO_aio_sync_file_range, file, "$$$$;$");
        (void)newXSproto_portable("IO::AIO::aio_fallocate", XS_IO__AIO_aio_fallocate, file, "$$$$;$");
        (void)newXSproto_portable("IO::AIO::aio_close", XS_IO__AIO_aio_close, file, "$;$");
        (void)newXSproto_portable("IO::AIO::aio_seek", XS_IO__AIO_aio_seek, file, "$$$;$");
        cv = newXSproto_portable("IO::AIO::aio_write", XS_IO__AIO_aio_read, file, "$$$$$;$");
        XSANY.any_i32 = EIO_WRITE;
        cv = newXSproto_portable("IO::AIO::aio_read", XS_IO__AIO_aio_read, file, "$$$$$;$");
        XSANY.any_i32 = EIO_READ;
        cv = newXSproto_portable("IO::AIO::aio_readlink", XS_IO__AIO_aio_readlink, file, "$;$");
        XSANY.any_i32 = EIO_READLINK;
        cv = newXSproto_portable("IO::AIO::aio_realpath", XS_IO__AIO_aio_readlink, file, "$;$");
        XSANY.any_i32 = EIO_REALPATH;
        (void)newXSproto_portable("IO::AIO::aio_sendfile", XS_IO__AIO_aio_sendfile, file, "$$$$;$");
        (void)newXSproto_portable("IO::AIO::aio_readahead", XS_IO__AIO_aio_readahead, file, "$$$;$");
        cv = newXSproto_portable("IO::AIO::aio_statvfs", XS_IO__AIO_aio_stat, file, "$;$");
        XSANY.any_i32 = EIO_STATVFS;
        cv = newXSproto_portable("IO::AIO::aio_lstat", XS_IO__AIO_aio_stat, file, "$;$");
        XSANY.any_i32 = EIO_LSTAT;
        cv = newXSproto_portable("IO::AIO::aio_stat", XS_IO__AIO_aio_stat, file, "$;$");
        XSANY.any_i32 = EIO_STAT;
        cv = newXSproto_portable("IO::AIO::major", XS_IO__AIO_major, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("IO::AIO::minor", XS_IO__AIO_major, file, "$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("IO::AIO::makedev", XS_IO__AIO_makedev, file, "$$");
        (void)newXSproto_portable("IO::AIO::aio_utime", XS_IO__AIO_aio_utime, file, "$$$;$");
        (void)newXSproto_portable("IO::AIO::aio_truncate", XS_IO__AIO_aio_truncate, file, "$$;$");
        (void)newXSproto_portable("IO::AIO::aio_chmod", XS_IO__AIO_aio_chmod, file, "$$;$");
        (void)newXSproto_portable("IO::AIO::aio_chown", XS_IO__AIO_aio_chown, file, "$$$;$");
        (void)newXSproto_portable("IO::AIO::aio_readdirx", XS_IO__AIO_aio_readdirx, file, "$$;$");
        (void)newXSproto_portable("IO::AIO::aio_mkdir", XS_IO__AIO_aio_mkdir, file, "$$;$");
        cv = newXSproto_portable("IO::AIO::aio_readdir", XS_IO__AIO_aio_unlink, file, "$;$");
        XSANY.any_i32 = EIO_READDIR;
        cv = newXSproto_portable("IO::AIO::aio_unlink", XS_IO__AIO_aio_unlink, file, "$;$");
        XSANY.any_i32 = EIO_UNLINK;
        cv = newXSproto_portable("IO::AIO::aio_rmdir", XS_IO__AIO_aio_unlink, file, "$;$");
        XSANY.any_i32 = EIO_RMDIR;
        cv = newXSproto_portable("IO::AIO::aio_rename", XS_IO__AIO_aio_link, file, "$$;$");
        XSANY.any_i32 = EIO_RENAME;
        cv = newXSproto_portable("IO::AIO::aio_symlink", XS_IO__AIO_aio_link, file, "$$;$");
        XSANY.any_i32 = EIO_SYMLINK;
        cv = newXSproto_portable("IO::AIO::aio_link", XS_IO__AIO_aio_link, file, "$$;$");
        XSANY.any_i32 = EIO_LINK;
        (void)newXSproto_portable("IO::AIO::aio_mknod", XS_IO__AIO_aio_mknod, file, "$$$;$");
        cv = newXSproto_portable("IO::AIO::aio_msync", XS_IO__AIO_aio_mtouch, file, "$;$$$$");
        XSANY.any_i32 = EIO_MSYNC;
        cv = newXSproto_portable("IO::AIO::aio_mtouch", XS_IO__AIO_aio_mtouch, file, "$;$$$$");
        XSANY.any_i32 = EIO_MTOUCH;
        (void)newXSproto_portable("IO::AIO::aio_mlock", XS_IO__AIO_aio_mlock, file, "$;$$$");
        (void)newXSproto_portable("IO::AIO::aio_mlockall", XS_IO__AIO_aio_mlockall, file, "$;$");
        (void)newXSproto_portable("IO::AIO::aio_fiemap", XS_IO__AIO_aio_fiemap, file, "$$$$$;$");
        (void)newXSproto_portable("IO::AIO::aio_busy", XS_IO__AIO_aio_busy, file, "$;$");
        (void)newXSproto_portable("IO::AIO::aio_group", XS_IO__AIO_aio_group, file, ";$");
        cv = newXSproto_portable("IO::AIO::aio_sync", XS_IO__AIO_aio_nop, file, ";$");
        XSANY.any_i32 = EIO_SYNC;
        cv = newXSproto_portable("IO::AIO::aio_nop", XS_IO__AIO_aio_nop, file, ";$");
        XSANY.any_i32 = EIO_NOP;
        (void)newXSproto_portable("IO::AIO::aioreq_pri", XS_IO__AIO_aioreq_pri, file, ";$");
        (void)newXSproto_portable("IO::AIO::aioreq_nice", XS_IO__AIO_aioreq_nice, file, ";$");
        (void)newXSproto_portable("IO::AIO::flush", XS_IO__AIO_flush, file, "");
        (void)newXSproto_portable("IO::AIO::poll", XS_IO__AIO_poll, file, "");
        (void)newXSproto_portable("IO::AIO::poll_fileno", XS_IO__AIO_poll_fileno, file, "");
        (void)newXSproto_portable("IO::AIO::poll_cb", XS_IO__AIO_poll_cb, file, "");
        (void)newXSproto_portable("IO::AIO::poll_wait", XS_IO__AIO_poll_wait, file, "");
        (void)newXSproto_portable("IO::AIO::nreqs", XS_IO__AIO_nreqs, file, "");
        (void)newXSproto_portable("IO::AIO::nready", XS_IO__AIO_nready, file, "");
        (void)newXSproto_portable("IO::AIO::npending", XS_IO__AIO_npending, file, "");
        (void)newXSproto_portable("IO::AIO::nthreads", XS_IO__AIO_nthreads, file, "");
        (void)newXSproto_portable("IO::AIO::fadvise", XS_IO__AIO_fadvise, file, "$$$$");
        (void)newXSproto_portable("IO::AIO::sendfile", XS_IO__AIO_sendfile, file, "$$$$");
        (void)newXSproto_portable("IO::AIO::mmap", XS_IO__AIO_mmap, file, "$$$$$;$");
        (void)newXSproto_portable("IO::AIO::munmap", XS_IO__AIO_munmap, file, "$");
        cv = newXSproto_portable("IO::AIO::madvise", XS_IO__AIO_madvise, file, "$$;$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("IO::AIO::mprotect", XS_IO__AIO_madvise, file, "$$;$$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("IO::AIO::munlock", XS_IO__AIO_munlock, file, "$;$$");
        (void)newXSproto_portable("IO::AIO::munlockall", XS_IO__AIO_munlockall, file, "");
        (void)newXSproto_portable("IO::AIO::splice", XS_IO__AIO_splice, file, "$$$$$$");
        (void)newXSproto_portable("IO::AIO::tee", XS_IO__AIO_tee, file, "$$$$");
        (void)newXSproto_portable("IO::AIO::_on_next_submit", XS_IO__AIO__on_next_submit, file, "$");
        newXS("IO::AIO::WD::DESTROY", XS_IO__AIO__WD_DESTROY, file);
        newXS("IO::AIO::REQ::cancel", XS_IO__AIO__REQ_cancel, file);
        newXS("IO::AIO::REQ::cb", XS_IO__AIO__REQ_cb, file);
        newXS("IO::AIO::GRP::add", XS_IO__AIO__GRP_add, file);
        newXS("IO::AIO::GRP::cancel_subs", XS_IO__AIO__GRP_cancel_subs, file);
        newXS("IO::AIO::GRP::result", XS_IO__AIO__GRP_result, file);
        newXS("IO::AIO::GRP::errno", XS_IO__AIO__GRP_errno, file);
        newXS("IO::AIO::GRP::limit", XS_IO__AIO__GRP_limit, file);
        newXS("IO::AIO::GRP::feed", XS_IO__AIO__GRP_feed, file);
    }

    /* Initialisation Section */

#line 854 "AIO.xs"
{
  static const struct {
    const char *name;
    IV iv;
  } *civ, const_iv[] = {
#   define const_niv(name, value) { # name, (IV) value },
#   define const_iv(name) { # name, (IV) name },
#   define const_eio(name) { # name, (IV) EIO_ ## name },

    /* you have to re-run ./gendef0 after adding/Removing any constants here */

    const_iv (ENOSYS)
    const_iv (EXDEV)
    const_iv (EBADR)

    const_iv (O_RDONLY)
    const_iv (O_WRONLY)
    const_iv (O_RDWR)
    const_iv (O_CREAT)
    const_iv (O_TRUNC)
    const_iv (O_EXCL)
    const_iv (O_APPEND)

    const_iv (O_ASYNC)
    const_iv (O_DIRECT)
    const_iv (O_NOATIME)

    const_iv (O_CLOEXEC)
    const_iv (O_NOCTTY)
    const_iv (O_NOFOLLOW)
    const_iv (O_NONBLOCK)
    const_iv (O_EXEC)
    const_iv (O_SEARCH)
    const_iv (O_DIRECTORY)
    const_iv (O_DSYNC)
    const_iv (O_RSYNC)
    const_iv (O_SYNC)
    const_iv (O_TTY_INIT)

    const_iv (S_IFIFO)
    const_iv (S_IFCHR)
    const_iv (S_IFBLK)
    const_iv (S_IFLNK)
    const_iv (S_IFREG)
    const_iv (S_IFDIR)
    const_iv (S_IFWHT)
    const_iv (S_IFSOCK)
    const_iv (S_IFMT)

    const_niv (FADV_NORMAL    , POSIX_FADV_NORMAL)
    const_niv (FADV_SEQUENTIAL, POSIX_FADV_SEQUENTIAL)
    const_niv (FADV_RANDOM    , POSIX_FADV_RANDOM)
    const_niv (FADV_NOREUSE   , POSIX_FADV_NOREUSE)
    const_niv (FADV_WILLNEED  , POSIX_FADV_WILLNEED)
    const_niv (FADV_DONTNEED  , POSIX_FADV_DONTNEED)

    const_niv (MADV_NORMAL    , POSIX_MADV_NORMAL)
    const_niv (MADV_SEQUENTIAL, POSIX_MADV_SEQUENTIAL)
    const_niv (MADV_RANDOM    , POSIX_MADV_RANDOM)
    const_niv (MADV_WILLNEED  , POSIX_MADV_WILLNEED)
    const_niv (MADV_DONTNEED  , POSIX_MADV_DONTNEED)

    const_iv (ST_RDONLY)
    const_iv (ST_NOSUID)
    const_iv (ST_NODEV)
    const_iv (ST_NOEXEC)
    const_iv (ST_SYNCHRONOUS)
    const_iv (ST_MANDLOCK)
    const_iv (ST_WRITE)
    const_iv (ST_APPEND)
    const_iv (ST_IMMUTABLE)
    const_iv (ST_NOATIME)
    const_iv (ST_NODIRATIME)
    const_iv (ST_RELATIME)

    const_iv (PROT_NONE)
    const_iv (PROT_EXEC)
    const_iv (PROT_READ)
    const_iv (PROT_WRITE)

    /*const_iv (MAP_FIXED)*/
    const_iv (MAP_PRIVATE)
    const_iv (MAP_SHARED)
    const_iv (MAP_ANONYMOUS)

    /* linuxish */
    const_iv (MAP_HUGETLB)
    const_iv (MAP_LOCKED)
    const_iv (MAP_NORESERVE)
    const_iv (MAP_POPULATE)
    const_iv (MAP_NONBLOCK)

    const_iv (FIEMAP_FLAG_SYNC)
    const_iv (FIEMAP_FLAG_XATTR)
    const_iv (FIEMAP_FLAGS_COMPAT)
    const_iv (FIEMAP_EXTENT_LAST)
    const_iv (FIEMAP_EXTENT_UNKNOWN)
    const_iv (FIEMAP_EXTENT_DELALLOC)
    const_iv (FIEMAP_EXTENT_ENCODED)
    const_iv (FIEMAP_EXTENT_DATA_ENCRYPTED)
    const_iv (FIEMAP_EXTENT_NOT_ALIGNED)
    const_iv (FIEMAP_EXTENT_DATA_INLINE)
    const_iv (FIEMAP_EXTENT_DATA_TAIL)
    const_iv (FIEMAP_EXTENT_UNWRITTEN)
    const_iv (FIEMAP_EXTENT_MERGED)
    const_iv (FIEMAP_EXTENT_SHARED)

    const_iv (SPLICE_F_MOVE)
    const_iv (SPLICE_F_NONBLOCK)
    const_iv (SPLICE_F_MORE)
    const_iv (SPLICE_F_GIFT)

    const_iv (SEEK_DATA)
    const_iv (SEEK_HOLE)

    /* libeio constants */
    const_eio (SEEK_SET)
    const_eio (SEEK_CUR)
    const_eio (SEEK_END)

    const_eio (MCL_FUTURE)
    const_eio (MCL_CURRENT)

    const_eio (MS_ASYNC)
    const_eio (MS_INVALIDATE)
    const_eio (MS_SYNC)

    const_eio (MT_MODIFY)

    const_eio (SYNC_FILE_RANGE_WAIT_BEFORE)
    const_eio (SYNC_FILE_RANGE_WRITE)
    const_eio (SYNC_FILE_RANGE_WAIT_AFTER)

    const_eio (FALLOC_FL_KEEP_SIZE)

    const_eio (READDIR_DENTS)
    const_eio (READDIR_DIRS_FIRST)
    const_eio (READDIR_STAT_ORDER)
    const_eio (READDIR_FOUND_UNKNOWN)

    const_eio (DT_UNKNOWN)
    const_eio (DT_FIFO)
    const_eio (DT_CHR)
    const_eio (DT_DIR)
    const_eio (DT_BLK)
    const_eio (DT_REG)
    const_eio (DT_LNK)
    const_eio (DT_SOCK)
    const_eio (DT_WHT)
  };

  aio_stash     = gv_stashpv ("IO::AIO"     , 1);
  aio_req_stash = gv_stashpv ("IO::AIO::REQ", 1);
  aio_grp_stash = gv_stashpv ("IO::AIO::GRP", 1);
  aio_wd_stash  = gv_stashpv ("IO::AIO::WD" , 1);

  for (civ = const_iv + sizeof (const_iv) / sizeof (const_iv [0]); civ > const_iv; civ--)
    newCONSTSUB (aio_stash, (char *)civ[-1].name, newSViv (civ[-1].iv));

  newCONSTSUB (aio_stash, "PAGESIZE", newSViv (PAGESIZE));

  reinit ();
}

#line 1836 "AIO.xs"
{
  newCONSTSUB (aio_stash, "CWD"       , newSVaio_wd (EIO_CWD       ));
  newCONSTSUB (aio_stash, "INVALID_WD", newSVaio_wd (EIO_INVALID_WD));
}

#line 3643 "AIO.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

